import java.util.*;
/**
  *
  * Objekte der Klasse stellen eine Listenobjekt-Erstellungs-Aktion dar, welche rckgngig gemacht werden kann.
  *
  * @version 1.0 vom 27.11.2013
  * @author Daniel Garmann
  */

public class AktionListenobjekt extends Aktion {
  
  private Hauptspeicher hs;
  private Listenobjekt neuesObjekt, altesObjekt;
  private Zeiger zeiger;
  // Ende Attribute
  
  // Anfang Methoden
  public AktionListenobjekt(int typ, Hauptspeicher hs, Listenobjekt neuesObjekt, Zeiger zeiger, Listenobjekt altesObjekt) {  
    super(typ);
    this.hs = hs;
    this.neuesObjekt = neuesObjekt;
    this.altesObjekt = altesObjekt;
    this.zeiger = zeiger;
  }
  
  public void rueckgaengig() {
    if (this.typ == Aktion.OBJEKTERSTELLEN) {
      hs.loescheObjekt(neuesObjekt);
      zeiger.setReferenz(altesObjekt);
    }  
  }
  
  public void wiederholen() {
    if (this.typ == Aktion.OBJEKTERSTELLEN) {
      ArrayList objekte = new ArrayList();
      objekte.add(neuesObjekt);
      objekte.add(neuesObjekt.getZeigerEnde());
      hs.reaktivereDarstellungsobjekte(objekte);
      zeiger.setReferenz(neuesObjekt);
      
    }
  }
  
  // Ende Methoden
}
