import java.util.*;
/**
  *
  * Objekte der Klasse stellen eine Zeiger-Erstellungs-oder-Lsch-Aktion dar, welche rckgngig gemacht werden kann.
  *
  * @version 1.0 vom 27.11.2013
  * @author Daniel Garmann
  */

public class AktionZeiger extends Aktion {
  
  // Anfang Attribute
  private Zeiger zeiger;
  private Punkt zeigerEnde;
  private Hauptspeicher hs;
  // Ende Attribute
  
  // Anfang Methoden
  public AktionZeiger(int typ, Hauptspeicher hs, Zeiger zeiger) {  
    super(typ);
    this.hs = hs;
    this.zeiger = zeiger;   
    this.zeigerEnde = zeiger.getZeigerEnde();     
  }
  
  public void rueckgaengig() {
    if (this.typ == Aktion.ZEIGERERSTELLEN) {
      hs.loescheZeiger(zeiger);
    } else if (this.typ == Aktion.ZEIGERLOESCHEN) {
      //hs.reaktiviereZeiger(zeiger, zeigerEnde);      
      ArrayList objekte = new ArrayList();
      objekte.add(zeiger);
      objekte.add(zeigerEnde);
      hs.reaktivereDarstellungsobjekte(objekte);
    }  
  }
  
  public void wiederholen() {
    if (this.typ == ZEIGERERSTELLEN) {
      ArrayList objekte = new ArrayList();
      objekte.add(zeiger);
      objekte.add(zeigerEnde);
      hs.reaktivereDarstellungsobjekte(objekte);
    } else {
      hs.loescheZeiger(zeiger);
    }
  }
  // Ende Methoden
}
