import java.awt.*;
/**
  *
  * Objekte der Klasse knnen auf der Zeichenflche des virtuellen Hauptspeichers
  * dargestellt werden. Die Klasse ist Basisklasse fr die Hauptspeicherobjekte
  * (Listenobjekte und Zeiger) und Punkte (Zeigerende)
  *
  * @version 1.0 vom 23.11.2013
  * @author Daniel Garmann
  */

public abstract class Darstellungsobjekt {
  
  // Anfang Attribute
  private int x;
  private int y;
  public Optionen optionen;                      // Festlegung der Darstellung der Objekte
  // Ende Attribute
  
  // Anfang Methoden  
  
  /**
   * Konstruktor
   */
  public Darstellungsobjekt(int x, int y, Optionen optionen) {
    this.x = x;
    this.y = y;
    this.optionen = optionen;
  }
  
  public int getX() {
    return x;
  }

  public void setX(int x) {
    this.x = x;
  }

  public int getY() {
    return y;
  }

  public void setY(int y) {
    this.y = y;
  }
    
  public abstract void darstellen(Graphics2D g);
  
  
  // Ende Methoden
}
