import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import javax.swing.filechooser.FileFilter;
import javax.swing.filechooser.FileNameExtensionFilter;

/**
  * @version 2.1 from 05.01.2014
  * @author Daniel Garmann
  */

public class Gui extends JFrame {
  // Anfang Attribute
  private Hauptspeicher hs;                                // Virtueller Hauptspeicher
  private int startx, starty, dx, dy;                      // Position auf der Zeichenflche, wo der Benutzer geklickt hat
  private Darstellungsobjekt objekt = null;                // aktuell angeklicktes Darstellungsobjekt (Zeiger, Listenobjekt oder Punkt)
  private Stack<Aktion> rueckgaengigAktionen = new Stack();            // Stack mit den gettigten Aktionen 
  private Stack<Aktion> wiederholenAktionen = new Stack(); // Stack mit den Wiederholen-Aktionen
  
  private JButton jbZeiger = new JButton();                // Definition aller Icon-Buttons
  private ImageIcon jbZeigerIcon;
  private JButton jbSpeicherbereinigung = new JButton();
  private ImageIcon jbSpeicherbereinigungIcon;
  private JButton jbRueckgaengig = new JButton();
  private ImageIcon jbRueckgaengigIcon;
  private JButton jbWiederholen = new JButton();
  private ImageIcon jbWiederholenIcon;
  private JButton jbNeu = new JButton();
  private ImageIcon jbNeuIcon;
  private JButton jbLaden = new JButton();
  private ImageIcon jbLadenIcon;
  private JButton jbSpeichern = new JButton();
  private ImageIcon jbSpeichernIcon;
  private JButton jbListe = new JButton();
  private ImageIcon jbListeIcon;
  private JButton jbSchlange = new JButton();
  private ImageIcon jbSchlangeIcon;
  private JButton jbStapel = new JButton();
  private ImageIcon jbStapelIcon;

  private JFileChooser jfcOpenDialog;                      // Dateiauswahldialoge
  private JFileChooser jfcSaveDialog;

  private JPanel jpAusgabe = new JPanel(null, true);       // Zeichenflche fr den virtuellen Hauptspeicher
  // Ende Attribute

  public Gui (String title) {
    super (title);
    setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
    addComponentListener(new ComponentAdapter() 
    {  
        public void componentResized(ComponentEvent evt) {
          if (hs != null) {
            jpAusgabe.setBounds(10, 40, (int)(getContentPane().getBounds().getWidth()-20), (int)(getContentPane().getBounds().getHeight()-50));
            hs.setGroesse((Graphics2D)jpAusgabe.getGraphics(), (int)(getContentPane().getBounds().getWidth()-20), (int)(getContentPane().getBounds().getHeight()-50));
          }
          jbListe.setBounds(Math.max(296,(int)(getContentPane().getBounds().getWidth()-104)), 2, 30, 30);
          jbSchlange.setBounds(Math.max(328,(int)(getContentPane().getBounds().getWidth()-72)), 2, 30, 30);
          jbStapel.setBounds(Math.max(360,(int)(getContentPane().getBounds().getWidth()-40)), 2, 30, 30);
        }
    });    

    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();

    int frameWidth = d.width-50; 
    int frameHeight = d.height-100;
    setSize(frameWidth, frameHeight);
    int x = (d.width - getSize().width) / 2;
    int y = (d.height - getSize().height) / 2-25;
    setLocation(x, y);
    Container cp = getContentPane();
    cp.setLayout(null);

    // Anfang Komponenten
    
    // Icons fr die Buttons erstellen
    jbZeigerIcon = new ImageIcon(this.getClass().getResource("Auswahl.png"));
    jbSpeicherbereinigungIcon = new ImageIcon(this.getClass().getResource("SpeicherSaeubern.png"));
    jbRueckgaengigIcon = new ImageIcon(this.getClass().getResource("Rueckgaengig.png"));
    jbWiederholenIcon = new ImageIcon(this.getClass().getResource("Wiederholen.png"));
    jbNeuIcon = new ImageIcon(this.getClass().getResource("Neu.png"));
    jbLadenIcon = new ImageIcon(this.getClass().getResource("Laden.png"));
    jbSpeichernIcon = new ImageIcon(this.getClass().getResource("Speichern.png"));
    jbListeIcon = new ImageIcon(this.getClass().getResource("LineareListe.png"));
    jbSchlangeIcon = new ImageIcon(this.getClass().getResource("Schlange.png"));
    jbStapelIcon = new ImageIcon(this.getClass().getResource("Stapel.png"));
    
    // Dateidialoge initialisieren
    jfcOpenDialog = new JFileChooser(); 
    jfcSaveDialog = new JFileChooser();
    FileFilter filter = new FileNameExtensionFilter("Listenstruktur-Definition","txt"); 
    jfcOpenDialog.setFileFilter(filter);
    jfcSaveDialog.setFileFilter(filter);
    
    // Erstellung der Buttons
    jbZeiger.setBounds(10, 2, 30, 30);
    jbZeiger.setText("");
    jbZeiger.setMargin(new Insets(2, 2, 2, 2));
    jbZeiger.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jbZeiger_ActionPerformed(evt);
      }
    });
    jbZeiger.setIcon(jbZeigerIcon);
    jbZeiger.setToolTipText("lokale Variable erstellen: Referenz auf Listenelement");
    cp.add(jbZeiger);

    jbSpeicherbereinigung.setBounds(42, 2, 30, 30);
    jbSpeicherbereinigung.setText("");
    jbSpeicherbereinigung.setMargin(new Insets(2, 2, 2, 2));
    jbSpeicherbereinigung.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jbSpeicherbereinigung_ActionPerformed(evt);
      }
    });
    jbSpeicherbereinigung.setIcon(jbSpeicherbereinigungIcon);
    jbSpeicherbereinigung.setToolTipText("Speicherbereinigung");
    cp.add(jbSpeicherbereinigung);
    
    jbRueckgaengig.setBounds(232, 2, 30, 30);
    jbRueckgaengig.setText("");
    jbRueckgaengig.setMargin(new Insets(2, 2, 2, 2));
    jbRueckgaengig.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jbRueckgaengig_ActionPerformed(evt);
      }
    });
    jbRueckgaengig.setIcon(jbRueckgaengigIcon);
    jbRueckgaengig.setToolTipText("Rckgngig");
    cp.add(jbRueckgaengig);

    jbWiederholen.setBounds(264, 2, 30, 30);
    jbWiederholen.setText("");
    jbWiederholen.setMargin(new Insets(2, 2, 2, 2));
    jbWiederholen.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jbWiederholen_ActionPerformed(evt);
      }
    });
    jbWiederholen.setIcon(jbWiederholenIcon);
    jbWiederholen.setToolTipText("Wiederherstellen");
    cp.add(jbWiederholen);
    
    jbNeu.setBounds(104, 2, 30, 30);
    jbNeu.setText("");
    jbNeu.setMargin(new Insets(2, 2, 2, 2));
    jbNeu.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jbNeu_ActionPerformed(evt);
      }
    });
    jbNeu.setIcon(jbNeuIcon);
    jbNeu.setToolTipText("Neue Datenstruktur");
    cp.add(jbNeu);

    jbLaden.setBounds(136, 2, 30, 30);
    jbLaden.setText("");
    jbLaden.setMargin(new Insets(2, 2, 2, 2));
    jbLaden.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jbLaden_ActionPerformed(evt);
      }
    });
    jbLaden.setIcon(jbLadenIcon);
    jbLaden.setToolTipText("ffnen...");
    cp.add(jbLaden);

    jbSpeichern.setBounds(168, 2, 30, 30);
    jbSpeichern.setText("");
    jbSpeichern.setMargin(new Insets(2, 2, 2, 2));
    jbSpeichern.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jbSpeichern_ActionPerformed(evt);
      }
    });
    jbSpeichern.setIcon(jbSpeichernIcon);
    jbSpeichern.setToolTipText("Speichern...");
    cp.add(jbSpeichern);

    jbListe.setBounds(getWidth()-112, 2, 30, 30);
    jbListe.setText("");
    jbListe.setMargin(new Insets(2, 2, 2, 2));
    jbListe.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jbListe_ActionPerformed(evt);
      }
    });
    jbListe.setIcon(jbListeIcon);
    jbListe.setToolTipText("Datenstruktur Lineare Liste");
    cp.add(jbListe);
    
    jbSchlange.setBounds(getWidth()-80, 2, 30, 30);
    jbSchlange.setText("");
    jbSchlange.setMargin(new Insets(2, 2, 2, 2));
    jbSchlange.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jbSchlange_ActionPerformed(evt);
      }
    });
    jbSchlange.setIcon(jbSchlangeIcon);
    jbSchlange.setToolTipText("Datenstruktur Schlange");
    cp.add(jbSchlange);
    
    jbStapel.setBounds(getWidth()-48, 2, 30, 30);
    jbStapel.setText("");
    jbStapel.setMargin(new Insets(2, 2, 2, 2));
    jbStapel.addActionListener(new ActionListener() { 
      public void actionPerformed(ActionEvent evt) { 
        jbStapel_ActionPerformed(evt);
      }
    });
    jbStapel.setIcon(jbStapelIcon);
    jbStapel.setToolTipText("Datenstruktur Stapel");
    cp.add(jbStapel);

    
    // Erstellung der Zeichenflche
    jpAusgabe.setBounds(10, 40, getWidth()-35, getHeight()-86);
    jpAusgabe.setOpaque(true);
    jpAusgabe.setBackground(Color.LIGHT_GRAY);
    jpAusgabe.addMouseMotionListener(new MouseMotionAdapter() { 
      public void mouseDragged(MouseEvent evt) { 
        jpAusgabe_MouseDragged(evt);
      }
    });
    jpAusgabe.addMouseListener(new MouseAdapter() { 
      public void mousePressed(MouseEvent evt) { 
        jpAusgabe_MousePressed(evt);
      }
    });
    jpAusgabe.addMouseListener(new MouseAdapter() { 
      public void mouseReleased(MouseEvent evt) { 
        jpAusgabe_MouseReleased(evt);
      }
    });
    cp.add(jpAusgabe);

    // Ende Komponenten
    setResizable(true);
    setVisible(true);
    
    // Erstellung des Hauptspeichers. Dieser bentigt die Zeichenflche fr die Darstellung.
    hs = new Hauptspeicher((Graphics2D)jpAusgabe.getGraphics(), jpAusgabe.getWidth(), jpAusgabe.getHeight());
    repaint();
  }

  // Anfang Methoden
 
  
  public void paint(Graphics g) {
    super.paint(g);
    if (hs != null) {
      hs.darstellen();
    }
    jbRueckgaengig.setEnabled(!rueckgaengigAktionen.isEmpty());
    jbWiederholen.setEnabled(!wiederholenAktionen.isEmpty());
  }

  /**
   * Methode, welche die Auswahl eines Dateinamens ber einen ffnen-Dialog ermglicht
   * @return Dateiname
   */  
  public String jfcOpenDialogOpenFilename() {
    jfcOpenDialog.setDialogTitle("ffne Datei");
    jfcOpenDialog.setCurrentDirectory(new File(System.getProperty("user.dir"))); // Verzeichnis auf aktuelles Projektverzeichnis setzen
    if (jfcOpenDialog.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
      return jfcOpenDialog.getSelectedFile().getPath();
    } else {
      return null;
    }
  }

  /**
   * Methode, welche die Auswahl eines Dateinamens ber einen Speichern-Dialog ermglicht
   * @return Dateiname
   */  
  public String jfcSaveDialogSaveFilename() {
    jfcSaveDialog.setDialogTitle("Speichere Datei");
    jfcSaveDialog.setCurrentDirectory(new File(System.getProperty("user.dir"))); // Verzeichnis auf aktuelles Projektverzeichnis setzen
    if (jfcSaveDialog.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
      return jfcSaveDialog.getSelectedFile().getPath();
    } else {
      return null;
    }
  }
  
  /**
   * Ereignis-Methode fr den Button: Neuer Zeiger
   * @param evt Das ActionEvent der Maus
   */  
  public void jbZeiger_ActionPerformed(ActionEvent evt) {
    if ((hs.gibListenstrukturTyp() == Hauptspeicher.SCHLANGE && hs.gibAnzahlZeiger() < hs.optionen.queueReferences) ||
        (hs.gibListenstrukturTyp() == Hauptspeicher.STAPEL && hs.gibAnzahlZeiger() < hs.optionen.stackReferences) ||
        (hs.gibListenstrukturTyp() == Hauptspeicher.LINEARELISTE && hs.gibAnzahlZeiger() < hs.optionen.listReferences) ||
        (hs.gibListenstrukturTyp() == Hauptspeicher.FREIEDATENSTRUKTUR && hs.gibAnzahlZeiger() < hs.optionen.freeReferences)) {
      int nr = 1;
      while(hs.exisitiertZeiger(hs.optionen.labelReference + nr)) nr++;
      String name = JOptionPane.showInputDialog(this,"Name der Referenz auf ein Listenelement",hs.optionen.labelReference + nr);
      if (name != null) {
        Zeiger z = hs.neuerZeiger(name);
        rueckgaengigAktionen.push(new AktionZeiger(Aktion.ZEIGERERSTELLEN, hs, z));
        wiederholenAktionen.clear();
        if (z == null) {
          JOptionPane.showMessageDialog(this,"Es exisitiert bereits eine Referenz mit dem Namen " + name);
        }
      }
    } else {
      JOptionPane.showMessageDialog(this,"Maximalanzahl an Referenzen erreicht!");
    }
    repaint();
  }

  /**
   * Ereignis-Methode fr den Button: Speicherbereinigung
   * @param evt Das ActionEvent der Maus
   */  
  public void jbSpeicherbereinigung_ActionPerformed(ActionEvent evt) {    
    ArrayList<Darstellungsobjekt> geloeschteObjekte = hs.speicherbereinigung();
    rueckgaengigAktionen.push(new AktionSpeicherbereinigung(Aktion.SPEICHERBEREINIGUNG, hs, geloeschteObjekte));
    wiederholenAktionen.clear();
    repaint();
  }

  /**
   * Ereignis-Methode fr den Button: Rckgngig
   * @param evt Das ActionEvent der Maus
   */  
  public void jbRueckgaengig_ActionPerformed(ActionEvent evt) {
    if (rueckgaengigAktionen.empty() == false) {
      Aktion a = rueckgaengigAktionen.pop();
      a.rueckgaengig();
      wiederholenAktionen.push(a);
      hs.aktualisiereListenobjekte();
    }
    repaint();
  }

  /**
   * Ereignis-Methode fr den Button: Wiederholen
   * @param evt Das ActionEvent der Maus
   */  
  public void jbWiederholen_ActionPerformed(ActionEvent evt) {
    if (wiederholenAktionen.empty() == false) {
      Aktion a = wiederholenAktionen.pop();
      a.wiederholen();
      rueckgaengigAktionen.push(a);
      hs.aktualisiereListenobjekte();
    }
    repaint();
  }

  /**
   * Ereignis-Methode fr den Button: Neue Datenstruktur
   * @param evt Das ActionEvent der Maus
   */  
  public void jbNeu_ActionPerformed(ActionEvent evt) {
    if (JOptionPane.showConfirmDialog(this, "Aktuelle Datenstruktur verwerfen?", "Datenstruktur verwerfen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
      hs.setListenstrukturTyp(Hauptspeicher.FREIEDATENSTRUKTUR);
      rueckgaengigAktionen.clear();
    }
    repaint();
  }

  /**
   * Ereignis-Methode fr den Button: ffnen einer Datenstruktur
   * @param evt Das ActionEvent der Maus
   */  
  public void jbLaden_ActionPerformed(ActionEvent evt) {
    String dateiname = jfcOpenDialogOpenFilename();
    if (dateiname != null) {
      rueckgaengigAktionen.clear();
      hs.laden(dateiname);
    }
    repaint();
  }

  /**
   * Ereignis-Methode fr den Button: Speichern einer Datenstruktur
   * @param evt Das ActionEvent der Maus
   */  
  public void jbSpeichern_ActionPerformed(ActionEvent evt) {
    String dateiname = jfcSaveDialogSaveFilename();
    if (dateiname != null) {
      rueckgaengigAktionen.clear();
      hs.speichern(dateiname);
    }
    repaint();
  }


  /**
   * Ereignis-Methode fr den Button: Datenstruktur Lineare Listte
   * @param evt Das ActionEvent der Maus
   */  
  public void jbListe_ActionPerformed(ActionEvent evt) {
    if (JOptionPane.showConfirmDialog(this, "Aktuelle Datenstruktur verwerfen?", "Datenstruktur verwerfen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
      hs.setListenstrukturTyp(Hauptspeicher.LINEARELISTE);
      rueckgaengigAktionen.clear();
    }
    repaint();
  }


  /**
   * Ereignis-Methode fr den Button: Datenstruktur Schlange
   * @param evt Das ActionEvent der Maus
   */  
  public void jbSchlange_ActionPerformed(ActionEvent evt) {
    if (JOptionPane.showConfirmDialog(this, "Aktuelle Datenstruktur verwerfen?", "Datenstruktur verwerfen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
      hs.setListenstrukturTyp(Hauptspeicher.SCHLANGE);
      rueckgaengigAktionen.clear();
    }
    repaint();
  }


  /**
   * Ereignis-Methode fr den Button: Datenstruktur Stapel
   * @param evt Das ActionEvent der Maus
   */  
  public void jbStapel_ActionPerformed(ActionEvent evt) {
    if (JOptionPane.showConfirmDialog(this, "Aktuelle Datenstruktur verwerfen?", "Datenstruktur verwerfen", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
      hs.setListenstrukturTyp(Hauptspeicher.STAPEL);
      rueckgaengigAktionen.clear();
    }
    repaint();
  }

  /**
   * Ereignis-Methode fr die Zeichenflche, hier fr das Event: MousePressed
   * @param evt Das ActionEvent der Maus
   */  
  public void jpAusgabe_MousePressed(MouseEvent evt) {
    // Startkoordinaten des Mausevents global merken (wichtig fr Verschiebung von Objekte)
    startx = evt.getX();
    starty = evt.getY();
    // Festestellen, welches Objekt angeklickt wurde
    objekt = hs.gibObjektAnStelle(startx, starty);
    // Wenn en Objekt angeklickt wurde, dann berechnen, wo genau das Objekt angeklickt wurde (relative Koordinaten)
    if (objekt != null) {
      dx = objekt.getX() - startx;
      dy = objekt.getY() - starty;
    }
    // Wenn ein Punkt angeklickt wurde, dann wird eine Vernderung einer Referenz vorgenommen. Dies muss fr die Rckgngig-Aktion gemerkt werden.
    if (objekt instanceof Punkt) {
      Punkt p = (Punkt)objekt;
      rueckgaengigAktionen.push(new AktionReferenz(Aktion.REFERENZSETZEN, p, p.getBesitzer().getReferenz(), null));      
      wiederholenAktionen.clear();
    // Wenn ein Zeiger angeklickt wurde, dann knnte ein Button des Zeigers angeklickt worden sein:
    } else if (objekt instanceof Zeiger) {
      Zeiger z = (Zeiger)objekt;
      // beim Plus-Button wird ein neues Listenobjekt erstellt.
      if (z.gibButton(startx, starty) == Zeiger.BUTTON_PLUS) {
        Listenobjekt altesObjekt = z.getReferenz();
        Listenobjekt neuesObjekt = hs.neuesObjekt(z);
        rueckgaengigAktionen.push(new AktionListenobjekt(Aktion.OBJEKTERSTELLEN, hs, neuesObjekt, z, altesObjekt)); 
        wiederholenAktionen.clear();
      // beim Null-Button wird die Referenz des Zeigers auf null gesetzt.  
      } else if (z.gibButton(startx, starty) == Zeiger.BUTTON_NULL) {
        rueckgaengigAktionen.push(new AktionReferenz(Aktion.REFERENZSETZEN, z.getZeigerEnde(), z.getReferenz(), null));      
        wiederholenAktionen.clear();
        z.setReferenz(null);
        z.getZeigerEnde().setX(z.getX()+80);
        z.getZeigerEnde().setY(z.getY()+25);
      // beim Schlieen-Button (rotes X) muss der Zeiger aus dem Hauptspeicher entfernt werden.
      } else if (z.gibButton(startx, starty) == Zeiger.BUTTON_DISPOSE) {
        rueckgaengigAktionen.push(new AktionZeiger(Aktion.ZEIGERLOESCHEN, hs, z));      
        wiederholenAktionen.clear();
        hs.loescheZeiger(z);
      } 
    // Wenn ein Listenobjekt angeklickt wurde, dann knnte auch ein Button des Listenobjekts angeklickt worden sein:
    } else if (objekt instanceof Listenobjekt) {    
      Listenobjekt l = (Listenobjekt)objekt;
      // Nur wenn das Listenobjekt direkt ber einen Zeiger erreichbar ist, darf das Listenobjekt verndert werden.
      if (l.getStatus() == Listenobjekt.DIREKTERREICHBAR) {
        // Wird der Null-Button gedrckt, so wird die Referenz des Listenobjekts auf null gesetzt.
        if (l.gibButton(startx, starty) == Listenobjekt.BUTTON_NULL) {
          rueckgaengigAktionen.push(new AktionReferenz(Aktion.REFERENZSETZEN, l.getZeigerEnde(), l.getReferenz(), null));
          wiederholenAktionen.clear();
          l.setReferenz(null);
          l.getZeigerEnde().setX(l.getX()+130);
          l.getZeigerEnde().setY(l.getY()+25);
        // Wird der Inhalt-Button gedrckt, so kann der Benutzer den Inhalt des Listenobjekts neu setzen.  
        } else if (l.gibButton(startx, starty) == Listenobjekt.BUTTON_CONTENT) {
          String inhalt = JOptionPane.showInputDialog(this,"Neues Inhaltsobjekt:",l.getInhalt());
          if (inhalt != null) {
            rueckgaengigAktionen.push(new AktionInhalt(Aktion.INHALTBELEGEN, l, l.getInhalt(), inhalt));
            wiederholenAktionen.clear();
            l.setInhalt(inhalt);
          }
        }
      }
    }     
    hs.darstellen();
    repaint();
  }     

  /**
   * Ereignis-Methode fr die Zeichenflche, hier fr das Event: MouseDragged
   * @param evt Das ActionEvent der Maus
   */  
  public void jpAusgabe_MouseDragged(MouseEvent evt) {
    // Nur, wenn vorher ein Objekt angeklickt wurde, muss ein Objekt verschoben werden.
    if (objekt != null) {            
      // das Objekt wird verschoben
      
      objekt.setX(evt.getX() + dx);
      objekt.setY(evt.getY() + dy);
      // bei einem Punkt knnte eine Referenz verndert werden
      if (objekt instanceof Punkt) {
        Punkt zeigerEnde = (Punkt)objekt;
        // wird der Punkt auf ein anderes Objekt gezogen:
        Darstellungsobjekt objekt = hs.gibObjektAnStelle(evt.getX(), evt.getY());        
        // dann nur etwas tun, wenn das referenzierte Objekt ein (direkt oder indirekt) erreichbares Listenobjekt ist.
        if (objekt instanceof Listenobjekt &&
            ((Listenobjekt)objekt).getStatus() <= Listenobjekt.INDIREKTERREICHBAR) {
          // das referenziertes Listenobjekt merken
          Listenobjekt neueReferenz = (Listenobjekt)objekt;
          // bei Zeigern kann man Referenz direkt setzen.
          if (zeigerEnde.getBesitzer() instanceof Zeiger) {
            Zeiger besitzer = (Zeiger)zeigerEnde.getBesitzer();
            besitzer.setReferenz(neueReferenz);
            hs.aktualisiereListenobjekte();
          // bei Listenobjekten geht es nur, wenn das Listenobjekt direkt erreichbar ist.   
          } else if (zeigerEnde.getBesitzer() instanceof Listenobjekt) {
            Listenobjekt besitzer = (Listenobjekt)zeigerEnde.getBesitzer();
            if (besitzer.getStatus() == Listenobjekt.DIREKTERREICHBAR) {
              besitzer.setReferenz(neueReferenz);
            }
          }
        // wenn der Punkt auf ein Objekt gezogen wurde, welches kein erreichbares Listenobjekt ist,
        } else {
          // dann zwischen Zeiger und Listenobjekt unterscheiden. Soll die Referenz eines Zeiger gendert werden,
          if (zeigerEnde.getBesitzer() instanceof Zeiger) {
            // dann die Referenz des zugehrigen Zeigers auf null setzen.
            Zeiger besitzer = (Zeiger)zeigerEnde.getBesitzer();
            besitzer.setReferenz(null);
            // sonst die Referenz des Listenobjekts auf null setzen (aber nur, wenn das Listenobjekt verndert werden darf (direkt erreichbar)
          } else if (zeigerEnde.getBesitzer() instanceof Listenobjekt) {
            Listenobjekt besitzer = (Listenobjekt)zeigerEnde.getBesitzer();
            if (besitzer.getStatus() == Listenobjekt.DIREKTERREICHBAR) {
              besitzer.setReferenz(null);
            }
          }
        }
      }   
    }
    hs.darstellen();
  }

  /**
   * Ereignis-Methode fr die Zeichenflche, hier fr das Event: MouseReleased
   * @param evt Das ActionEvent der Maus
   */  
  public void jpAusgabe_MouseReleased(MouseEvent evt) {    
    // Nur, wenn vorher ein Objekt angeklickt wurde, muss ein Objekt verschoben werden.
    if (objekt != null) {            
      // Wurde ein Punkt gezogen, so wurde eine Referenz verndert. Fr die Rckgngig-Aktion muss die neue Referenz gespeichert werden
      if (objekt instanceof Punkt) {
        Punkt p = (Punkt)objekt;      
        ((AktionReferenz)rueckgaengigAktionen.peek()).setNeueReferenz(p.getBesitzer().getReferenz());
      // andernfalls hat der Anwender evtl. nur ein Objekt verschoben.
      } else {
        if (evt.getX() != startx || evt.getY() != starty) {
          rueckgaengigAktionen.push(new AktionVerschieben(Aktion.VERSCHIEBEN, objekt, evt.getX()-startx, evt.getY()-starty));
          wiederholenAktionen.clear();
        }
      }
      hs.aktualisiereListenobjekte();
    }
    hs.darstellen();
    repaint();
  }



  // Ende Methoden

  public static void main(String[] args) {
    new Gui("Dynamische Listenstrukturen - Visualisierung");
  }
}
