import java.io.*;
import java.util.*; 
import java.net.URL;
/**
  *
  * Festlegung der Optionen, wie Zeiger und Listenelemente dargestellt werden
  * und welche Obergrenzen fr die Anzahl der Zeiger exisitieren.
  *
  * @version 1.0 from 23.10.2014
  * @Daniel Garmann 
  */

public class Optionen {

  // Anfang Attribute
  public  String labelNew = "new";                         // Beschriftung auf einer Referenz zur Erstellung eines neuen Objekts
  public  String labelNull = "null";                       // Beschriftung einer Referenz, welche auf null verweist
  public  String labelReference = "reference";              // Standard-Name einer neuen Referenz
  public  String labelEmpty = "<empty>";                  // Standard-Inhalt eines neuen Objekts
  public  int freeReferences = 6;                          // maximale Anzahl an Referenzen, wenn keine Datenstruktur gewhlt ist.
  public  int stackReferences = 3;                         // maximale Anzahl an Referenzen bei der Datenstruktur Stack
  public  int queueReferences = 4;                         // maximale Anzahl an Referenzen bei der Datenstruktur Queue
  public  int fixedListReferences = 2;                     // Anzahl fester Referenzen. 2: nur First und Current, 3: First, Current und Last
  public  int listReferences = fixedListReferences + 3;    // maximale Anzahl an Referenzen bei der Datenstruktur List
  public  String labelReferenceListFirst = "first";       // Bezeichnung der festen Referenzen
  public  String labelReferenceListCurrent = "current";
  public  String labelReferenceListLast = "last";
  public  String labelReferenceQueueFirst = "head";
  public  String labelReferenceQueueLast = "tail";
  public  String labelReferenceStackFirst = "top";
  
  // Ende Attribute

  // Anfang Methoden
  
  public Optionen() {
    try{
      Properties p = new Properties();
      URL url = ClassLoader.getSystemResource("Optionen.ini");
      if (url != null) p.load(url.openStream());      
      
      labelNew = p.getProperty("labelNew");
      labelNull = p.getProperty("labelNull");
      labelReference = p.getProperty("labelReference");
      labelEmpty = p.getProperty("labelEmpty");
      freeReferences = Integer.parseInt(p.getProperty("freeReferences"));
      stackReferences = Integer.parseInt(p.getProperty("stackReferences"));
      queueReferences = Integer.parseInt(p.getProperty("queueReferences"));
      listReferences = Integer.parseInt(p.getProperty("listReferences"));
      fixedListReferences = Integer.parseInt(p.getProperty("fixedListReferences"));
      labelReferenceListFirst = p.getProperty("labelReferenceListFirst");
      labelReferenceListCurrent = p.getProperty("labelReferenceListCurrent");
      labelReferenceListLast = p.getProperty("labelReferenceListLast");
      labelReferenceQueueFirst = p.getProperty("labelReferenceQueueFirst");
      labelReferenceQueueLast = p.getProperty("labelReferenceQueueLast");
      labelReferenceStackFirst = p.getProperty("labelReferenceStackFirst");
      }
    catch (Exception e) {
      System.out.println(e);
    }
  }
    
  // Ende Methoden

}
